import os
import datetime
import tarfile
import os.path
import logging
import kraken.tools.Utils as Utils
import kraken.tools.TextUi as TextUi
from kraken.entrytypes.MetaData import loadMetaData
import kraken.Constants


def description(system, runtime):
    return """
    Export and import information from various formats.
    """
        

def execute(system, runtime):
   commands = [ 
      "Export BibTeX file",
      "Backup the whole kraken",
      "Export selected entries",
      "-",
      "Import kraken directory",
      "-",
      "Return to main menu"
   ]
   commandname = TextUi.inputMenu("Select the command to execute:", commands)
   if commandname == "Export BibTeX file":
       exportBibTeX(system, runtime)    
       return
   if commandname == "Backup the whole kraken":
       backupKraken(system, runtime)
       return
   ## ....
   if commandname == "Return to main menu":
       return
   print "Unrecognized choice" 
   return
   

#
#  Execute the command
#
def exportBibTeX(system, runtime):
    #print "Generating Bibtex..."
    metadata = loadMetaData(system, runtime)
    descriptor = metadata.descriptors["BibTex"]
    bibtexFile = "KrakenBibtex.bib"
    bibtexFile = TextUi.inputString("Name of bibtex file to generate:", bibtexFile)    
    FILE = open(bibtexFile, "w+")
    bibtexEntryCount = 0
    for entry in metadata.entries:        
        bibFilename = descriptor.getNativeFileName(entry) 
        if not os.path.exists(bibFilename):
           continue
        FILE.write("% Generated from kraken entry " + bibFilename + "\n")    
        BIBFILE = open(bibFilename)
        FILE.write(BIBFILE.read())
        BIBFILE.close()
        FILE.write("\n\n")
        bibtexEntryCount = bibtexEntryCount + 1
    FILE.close()
    print "Generated " + str(bibtexEntryCount) + " entries in file " + bibtexFile
    

def backupKraken(system, runtime):
    n = datetime.datetime.now()
    strmonth = ("0" + str(n.month))[-2:]
    strday = ("0" + str(n.day))[-2:]
    filename = "krakenbackup_" + str(n.year) + strmonth + strday + ".tgz"
    filename = TextUi.inputString("Backup file:", initvalue = filename)    
    TextUi.startLongCommand("Creating backup archive...\n")
    f = tarfile.open(filename,"w:gz")
    f.posix = False
    i = 0    
    for a in system.getProperty("krakenDirs"):
        print "   adding "+a        
        f.add(a, "krakendir"+str(i))
        i = i + 1
    f.close()
    TextUi.endLongCommand()    
